<?php

if(!defined('IN_IPB'))
{
	print "<h1>Incorrect access</h1>You cannot access this file directly. If you have recently upgraded, make sure you upgraded all the relevant files.";
	exit();
}

class app_class_awards
{
	protected $registry;
	protected $DB;
	protected $settings;
	protected $request;
	protected $member;
	
	public function __construct(ipsRegistry $registry)
	{
		$this->registry   = $registry;
		$this->DB         = $this->registry->DB();
		$this->settings   =& $this->registry->fetchSettings();
		$this->request    =& $this->registry->fetchRequest();
		$this->member     = $this->registry->member();
		$this->memberData =& $this->registry->member()->fetchMemberData();
		
		$this->loadApp_settings();
		
		if(IN_ACP)
		{	
			require_once(IPSLib::getAppDir('awards') . "/sources/classes/awards/class_awards.php");
			$classToLoad = IPSLib::loadLibrary(IPSLib::getAppDir('awards') . "/sources/classes/awards/admin_awards_functions.php", "admin_awards_functions", "awards");
			$this->registry->setClass('class_awards', new $classToLoad($registry));
		}
		else
		{
			$classToLoad = IPSLib::loadLibrary(IPSLib::getAppDir('awards') . "/sources/classes/awards/class_awards.php", "class_awards", "awards");
			$this->registry->setClass('class_awards', new $classToLoad($registry));
		}
	}
	
	private function loadApp_settings()
	{
		define('INV_APP_VERSION', '2.2.4');
		define('INV_APP_VERSION_LONG', '20204000000');
		define('INV_APP_NAME', 'awards');
		
		define('UPLOAD_FOLDER', '/awards/');
		define('UPLOAD_DIR', $this->settings['upload_dir'] . UPLOAD_FOLDER);
		define('UPLOAD_URL', $this->settings['upload_url'] . UPLOAD_FOLDER);
		
		define('AUTO_FUNCS_DIR', IPSLib::getAppDir('awards') . "/auto_awarding");
		
		# IF THE ROOT ADMIN IS NOT MEMBER NUMBER 1, CHANGE THIS BELOW TO THE CORRECT VALUE:
		define('SYSTEM_ROOT_ID', '1');
		define('DEFAULT_CAT', '1');
		
		define('MAX_POST_IMG_SIZE', '25x25');	
	}
	
	public function getThumb($url, $name, $environ)
	{
		if($environ == "sig")
		{
			$doIT = $this->settings['awds_sig_resize_icons'];
			$doBY = $this->settings['awds_sig_max_icon_size'];
		}
		else
		{
			$doIT = $this->settings['awd_auto_resize'];
			$doBY = $this->settings['awd_resize_size'];
		}
		
		if($doIT && function_exists('getimagesize'))
		{
			list($width, $height) = getimagesize($url);
			
			$split = split("x", $doBY);
			$maxW  = $split[0];
			$maxH  = $split[1];
			
			if($width > $maxW)
			{
				$lgr = $maxW / $width;
				
				$width  = $width * $lgr;
				$height = $height * $lgr;
			}
			
			if($height > $maxH)
			{
				$lgr = $maxH / $height;
				
				$width  = $width * $lgr;
				$height = $height * $lgr;
			}
		}
		
		return "<img src='{$url}' width='{$width}' height='{$height}' alt='{$name}' title='{$name}' /> ";
	}
	
	public function getAwardToolTip($a)
	{
		$tt = $this->settings['awds_tool_tip'];
		
		if(strpos($tt, '{awd_date}') !== FALSE)
		{
			$date = ipsRegistry::getClass('class_localization')->getDate($a['date'], 'LONG');
		}
		
		$search  = array('{awd_name}', '{awd_desc}', '{awd_notes}', '{awd_date}');
		$replace = array($a['name'], $a['desc'], $a['notes'], $date);
		
		return str_replace($search, $replace, $tt);
	}
}
?>