<?php
#######################################
## (inv) Awards #######################
#######################################
## Author:  Alec Carpenter
## Website: http://www.invisionenvy.com
#######################################
##                                ADMIN
## Module:  AWARDS
## Section: AUTO
#######################################
## VERSION: 2.2.4
#######################################

if(!defined('IN_ACP'))
{
	print "<h1>Incorrect access</h1>You cannot access this file directly. If you have recently upgraded, make sure you upgraded 'admin.php'.";
	exit();
}

class admin_awards_awards_auto extends ipsCommand
{
	private $output;
	
	function doExecute(ipsRegistry $registry) 
	{
		switch($this->request['do'])
		{
			case "add":
				$this->add_step_one();
				break;
			case "edit":
				$this->form('edit');
				break;
			case "delete":
				$this->delete();
				break;
			default:
				$this->main();
				break;
		}
		
		$this->registry->getClass('output')->html_main = $this->registry->getClass('output')->global_template->global_frame_wrapper();
		$this->registry->getClass('output')->html_main .= $this->output;
		$this->registry->getClass('output')->sendOutput();
	}
	
	private function main()
	{
		$enabledImage  = "<img src='{$this->settings['skin_acp_url']}/images/icons/tick.png' title='Disable' />";
		$disabledImage = "<img src='{$this->settings['skin_acp_url']}/images/icons/cross.png' title='Enable' />";
		
		$this->output .= "
		<div class='section_title'>
		  <h2>Auto Awarding Management</h2>
		  <ul class='context_menu'>
		    <li>
			  <a href='{$this->settings['base_url']}module=awards&section=auto&do=add'><img src='{$this->settings['skin_acp_url']}/_newimages/icons/add.png' alt='' />Add New Auto-Award Function</a>
		    </li>
		  </ul>
	    </div>";
		
		if(!is_readable(AUTO_FUNCS_DIR))
		{
			$this->output .= "<div class='warning'>Please make sure that the directory \"auto_awarding\" is readable by your system.</div>
			<br />";
		}
		
		$this->DB->build(array(
							   'select' => '*',
							   'from'   => 'inv_awards_auto_awards',
								));
		
		$loadFuncs = $this->DB->execute();
		
		if(!$this->DB->getTotalRows())
		{
			$rows = "
			<tr>
			  <td align='center'>
			    <em>There aren't any auto-award functions.</em>
			  </td>
			</tr>";
		}
		else
		{
			while($f = $this->DB->fetch($loadFuncs))
			{
				$this->DB->build(array(
									   'select' => '*',
									   'from'   => 'inv_awards',
									   'where'  => 'id = ' . $f['award_id'],
				));
				
				$getAward = $this->DB->execute();
				$a        = $this->DB->fetch($getAward);
				
				if($f['enabled'])
				{
					$status = "<a href='javascript: changeStatus_funcs({$f['inst_id']});' id='funcs_enabler_{$f['inst_id']}'>" . $enabledImage . "</a>";
				}
				else
				{
					$status = "<a href='javascript: changeStatus_funcs({$f['inst_id']});' id='funcs_enabler_{$f['inst_id']}'>" . $disabledImage . "</a>";
				}
				
				$r .= "
				<tr class='item ipsControlRow'>
				  <td>{$f['title']}</td>
				  <td>{$a['name']}</td>
				  <td align='center'>{$status}</td>
				  <td>
				    <ul class='ipsControlStrip'>
					  <li class='i_edit'>
						<a href='{$this->settings['base_url']}module=awards&section=auto&do=edit&id={$f['inst_id']}'>Edit</a>
					  </li>
					  <li class='i_delete'>
						<a href='{$this->settings['base_url']}module=awards&section=auto&do=delete&id={$f['inst_id']}'>Delete</a>
					  </li>
				    </ul>
				  </td>
				</tr>";
				
				$visibilityArray .= "funcsVisibility[{$f['inst_id']}] = {$f['enabled']};
				";
			}
			
			$rows = "
			<tr>
			  <th width='25%'>Function Title</th>
			  <th width='25%'>Award</th>
			  <th width='25%'><div align='center'>Enable/Disable</div></th>
			  <th></th>
			</tr>" . $r;
		}
		
		$this->output .= "
		<script type='text/javascript'>
		var stylesURL = '{$this->settings['skin_acp_url']}';
		var enabledIMG  = \"{$enabledImage}\";
		var disabledIMG = \"{$disabledImage}\";{$jsAwardCat}
		
		var funcsVisibility = [];
		{$visibilityArray}
		</script>
		<script type='text/javascript' src='applications_addon/other/awards/js/autoawarding.js'></script>
		<div class='acp-box'>
		  <h3>Auto-Award Functions</h3>
		  <table class='ipsTable'>
		    {$rows}
		  </table>
		</div>";
	}
	
	private function add_step_one()
	{
		if(isset($this->request['continue']) && $this->request['type'])
		{
			$this->form();
			
			return;
		}
		
		$opendir = @opendir(AUTO_FUNCS_DIR);
		
		if($opendir)
		{
			while(false != ($file = readdir($opendir)))
			{
				if(strpos($file, ".php"))
				{
					include_once(AUTO_FUNCS_DIR . "/{$file}");
					
					$class  = "auto_award_" . str_replace(".php", "", $file);
					
					if(class_exists($class))
					{
						$call   = new $class(ipsRegistry::instance());
						$CONFIG = $call->config();
						
						if($CONFIG['name_human'] && $CONFIG['name_cpu'])
						{
							$options = "<option value='{$CONFIG['name_cpu']}'>{$CONFIG['name_human']}</option>";
						}
						
						unset($CONFIG);
					}
				}
			}
		}
		else
		{
			$this->registry->output->showError('The following directory:<br /><br />' . AUTO_FUNCS_DIR . '<br /><br />Either does not exist, or it is not readable by your system.');
		}
		
		$this->output .= "
		<form name='typeOfAutoAward' method='post' action='{$this->settings['base_url']}module=awards&section=auto&do=add&continue'>
		<div class='acp-box'>
		  <h3>Adding New Auto-Award Function</h3>
		  <table class='ipsTable'>
		    <tr>
			  <td width='35%'><strong>Auto-Award Type</strong></td>
			  <td><select name='type' onChange='javascript: if(this.value){document.typeOfAutoAward.submit();}'><option value='' disabled selected>Please Choose One</option>{$options}</select></td>
			</tr>
		  </table>
	      <div class='acp-actionbar' align='center'><input type='submit' value=' Continue ' class='realbutton' /> or <strong><a href='{$this->settings['base_url']}module=awards&section=auto'>Cancel</a></strong></div>
		</div>
		</form>";
	}
	
	private function form($type='add')
	{
		if($type == "edit")
		{
			$this->DB->build(array(
								   'select' => '*',
								   'from'   => 'inv_awards_auto_awards',
								   'where'  => 'inst_id = ' . $this->request['id'],
			));
			
			$this->DB->execute();
			
			if(!$this->DB->getTotalRows())
			{
				$this->registry->output->showError('The URL you have followed is invalid');
			}
			
			$this->func     = $this->DB->fetch();
			$this->funcData = json_decode($this->func['data'], TRUE);
			
			$load = $this->func['type'];
		}
		else
		{
			$load = $this->request['type'];
		}
		
		$include = AUTO_FUNCS_DIR . "/" . $load . ".php";
		
		@include_once($include);
		
		$class  = "auto_award_" . $load;
		$call   = new $class(ipsRegistry::instance());
		$CONFIG = $call->config();
		
		if(isset($this->request['save']))
		{
			if(!$this->request['function_title'])
			{
				$this->output .= "
				<div class='warning' style='margin-bottom:15px;'>
				  <h4><img src={$this->settings['skin_acp_url']}/_newimages/icons/bullet_error.png' /> Error!</h4>
				  Please enter a title before continuing!
				</div>";
			}
			else
			{
				if(!$this->request['award'])
				{
					$this->output .= "
					<div class='warning' style='margin-bottom:15px;'>
					  <h4><img src={$this->settings['skin_acp_url']}/_newimages/icons/bullet_error.png' /> Error!</h4>
					  Please select an award before continuing!
					</div>";
				}
				else
				{
					$errors = "";
					$data   = array();
					
					foreach($CONFIG['data'] as $l => $i)
					{
						if(!$errors)
						{
							$v = $this->request[$i[2]];
							
							if(!$v && $i[3])
							{
								$errors = $l;
							}
							
							$data[$i[2]] = $v;
						}
					}
					
					if($errors)
					{
						$this->output .= "
						<div class='warning' style='margin-bottom:15px;'>
						  <h4><img src={$this->settings['skin_acp_url']}/_newimages/icons/bullet_error.png' /> Error!</h4>
						  You must enter something for field '{$errors}'.
						</div>";
					}
					else
					{
						$title        = $this->request['function_title'];
						$award        = $this->request['award'];
						$key          = $this->request['type'] ? $this->request['type'] : $load;
						$encoded_data = json_encode($data);
						$notes        = $this->request['notes'];
						
						$queryData = array(
										   'award_id' => $award,
										   'title'    => $title,
										   'type'     => $key,
										   'data'     => $encoded_data,
										   'notes'    => $notes,
						);
						
						if($type == "add")
						{
							$this->DB->insert('inv_awards_auto_awards', $queryData);
						}
						elseif($type == "edit")
						{
							$this->DB->update('inv_awards_auto_awards', $queryData, 'inst_id = \'' . $this->request['id'] . '\'');
						}
						
						$this->registry->output->global_message = "Auto-Award Function Saved";
						$this->registry->output->silentRedirectWithMessage($this->settings['base_url'] . "module=awards&section=auto");
					}
				}
			}
		}
		
		if(!$CONFIG['data'] || !count($CONFIG['data']))
		{
			$this->registry->output->showError('The configuration file for the auto-award function you have choosen is invalid. Make sure it includes a variable called $CONFIG[\'data\'].');
		}
		
		foreach($CONFIG['data'] as $label => $info)
		{
			$type = $info[1];
			
			if($this->funcData[$info[2]])
			{
				$value = $this->funcData[$info[2]];
			}
			
			if($this->request[$info[2]])
			{
				$value = $this->request[$info[2]];
			}
			
			if($type == "drop" && $info[4])
			{
				$field = $this->registry->output->formDropdown($info[2], $info[4], $value);
			}
			elseif($type == "multi" && $info[4])
			{
				if(!is_array($value))
				{
					$value = explode(",", $value);
				}
				
				$field = $this->registry->output->formMultiDropdown($info[2] . '[]'	, $info[4], $value);
			}
			elseif($type == "yesno" || $type == "yn")
			{
				$field = $this->registry->output->formYesNo($info[2], $value);
			}
			else
			{
				$field = $this->registry->output->formInput($info[2], IPSText::parseCleanValue($value));
			}
			
			if($info[0])
			{
				$desc = "<br />{$info['0']}";
			}
			
			$options .= "
			<tr>
			  <td><strong>{$label}</strong>{$desc}</td>
			  <td>{$field}</td>
			</tr>";
		}
		
		$title_value = $this->func['title'];
		
		if($this->request['function_title'])
		{
			$title_value = $this->request['function_title'];
		}
		
		$notes_value = $this->func['notes'];
		
		if($this->request['notes'])
		{
			$notes_value = $this->request['notes'];
		}
		
		$award_value = $this->func['award_id'];
		
		if($this->request['award'])
		{
			$award_value = $this->request['award'];
		}
		
		$awards_opt = $this->registry->getClass('class_awards')->awardsMenu("award", $award_value);
		
		if($this->request['do'] == "edit")
		{
			$submit = "{$this->settings['base_url']}module=awards&section=auto&do=edit&id={$this->request['id']}&save";
		}
		else
		{
			$submit = "{$this->settings['base_url']}module=awards&section=auto&do=add&continue&save";
		}
		
		$this->output .= "
		<form name='autoAwardFuncSettings' method='post' action='{$submit}'>
		<div class='acp-box'>
		  <h3>Managing Auto-Award Function</h3>
		  <table class='ipsTable'>
		    <tr>
			  <td width='35%'>
			    <strong>Function Title</strong><br />
				This is just to allow you to easily reffer to this specific function.
			  </td>
			  <td><input type='text' name='function_title' value='{$title_value}' style='width:200px;' /></td>
			</tr>
			<tr>
			  <td width='35%'>
			    <strong>Notes</strong><br />
				A short message for why the user would receive this award.
			  </td>
			  <td><input type='text' name='notes' value='{$notes_value}' style='width:400px;' /></td>
			</tr>
			<tr>
			  <td width='35%'>
			    <strong>Award to Give</strong><br />
				This is the award which will be given.
			  </td>
			  <td>{$awards_opt}</td>
			</tr>
			<tr>
			  <th colspan='2'>Other Options</th>
			</tr>
			{$options}
		  </table>
	      <div class='acp-actionbar' align='center'><input type='submit' value=' Save ' class='realbutton' /> or <strong><a href='{$this->settings['base_url']}module=awards&section=auto'>Cancel</a></strong></div>
		</div>
		<input type='hidden' name='type' value='{$this->request['type']}' />
		</form>";
		
		if($CONFIG['auth'])
		{
			if($CONFIG['web'])
			{
				$auth = "<a href='{$CONFIG['web']}' target='_blank'>{$CONFIG['auth']}</a>";
			}
			else
			{
				$auth = $CONFIG['auth'];
			}
			
			$this->output .= "
			<div style='margin-top:10px;'>
			  This auto-award function was created by {$auth}.
			</div>";
		}
	}
	
	private function delete()
	{
		$this->DB->build(array(
							   'select' => '*',
							   'from'   => 'inv_awards_auto_awards',
							   'where'  => 'inst_id = ' . $this->request['id'],
		));
		
		$this->DB->execute();
		
		if(!$this->DB->getTotalRows())
		{
			$this->registry->output->showError('The URL you have followed is invalid');
		}
		
		$f = $this->DB->fetch();
		
		if(isset($this->request['continue']) && $this->request['deleteFunc'] == $f['inst_id'])
		{
			$this->DB->delete('inv_awards_auto_awards', 'inst_id = ' . $f['inst_id']);
			
			if($this->request['deleteAwards'])
			{
				$this->DB->delete('inv_awards_awarded', 'auto_award_id = ' . $f['inst_id']);
			}
			
			$this->registry->output->global_message = "Auto-Award Function Deleted";
			$this->registry->output->silentRedirectWithMessage($this->settings['base_url'] . "module=awards&section=auto");
		}
		
		$this->DB->build(array(
							   'select' => '*',
							   'from'   => 'inv_awards_awarded',
							   'where'  => 'auto_award_id = ' . $f['inst_id'],
		));
		
		$this->DB->execute();
		
		if($this->DB->getTotalRows())
		{
			$deleteAwards = "
			<div class='tablerow1' style='padding:10px;'>
			  Awards have been given by this auto-award function, do you want to delete those too?<br />
			  <br />
			  Check if yes: <input type='checkbox' name='deleteAwards' value='1' />
		    </div>";
		}
		
		$this->output .= "
		<form name='deleteAward' method='post' action='{$this->settings['base_url']}module=awards&section=auto&do=delete&id={$this->request['id']}&continue'>
		<div class='acp-box'>
 		  <h3>Deleting Auto-Award Function: {$f['title']}</h3>
	      <div class='tablerow1' style='padding:10px;'>
			Are you sure that you would like to delete this auto-award function? This cannot be undone.
		  </div>
		  {$deleteAwards}
		  <div class='acp-actionbar'>
			<input type='hidden' name='deleteFunc' value='{$f['inst_id']}' />
			<input type='submit' value=' Yes, Delete ' class='realbutton' /> or <strong><a href='{$this->settings['base_url']}'>Cancel</a></strong>
	  	  </div>
        </div>
		</form>";
	}
}
?>