<?php
#######################################
## (inv) Awards #######################
#######################################
## Author:  Alec Carpenter
## Website: http://www.invisionenvy.com
#######################################
##                                ADMIN
## Module:  AWARDS
## Section: MANAGE
#######################################
## VERSION: 2.2.4
#######################################

if(!defined('IN_ACP'))
{
	print "<h1>Incorrect access</h1>You cannot access this file directly. If you have recently upgraded, make sure you upgraded 'admin.php'.";
	exit();
}

class admin_awards_awards_manage extends ipsCommand
{
	public function doExecute(ipsRegistry $registry) 
	{
		switch($this->request['do'])
		{
			case "delete":
				if($_GET['what'] == "award")
				{
					$this->deleteAward();
				}
				elseif($_GET['what'] == "category")
				{
					$this->deleteCategory();
				}
				else
				{
					$this->main();
				}
				break;
			case "add":
				$this->addAward();
				break;
			case "edit":
				$this->editAward();
				break;
			default:
				$this->main();
				break;
		}
		
		$this->registry->getClass('output')->html_main .= $this->registry->getClass('output')->global_template->global_frame_wrapper();
		$this->registry->getClass('output')->sendOutput();
	}
	
	private function addHeader()
	{
		$this->registry->getClass('output')->html_main = "
		<div class='section_title'>
		  <h2>Awards Management</h2>
		  <ul class='context_menu'>
		    <li>
			  <a href='{$this->settings['base_url']}module=awards&section=manage&do=add&what=award'><img src='{$this->settings['skin_acp_url']}/_newimages/icons/add.png' alt='' />Add New Award</a>
		    </li>
		    <li>
			  <a href='javascript: addCategory();' alt='' /><img src='{$this->settings['skin_acp_url']}/_newimages/icons/add.png' alt='' />Add New Category</a>
		    </li>
		  </ul>
	    </div>";
	}
	
	private function main()
	{
		$this->addHeader();
		
		# Set some stuff
		$enabledImage  = "<img src='{$this->settings['skin_acp_url']}/images/icons/tick.png' title='Disable' />";
		$disabledImage = "<img src='{$this->settings['skin_acp_url']}/images/icons/cross.png' title='Enable' />";
		
		$this->DB->build(array(
							   'select' => '*',
							   'from'   => 'inv_awards_cats',
							   'order'  => 'placement ASC',
							   
		));
		
		$getCats = $this->DB->execute();
		
		while($cat = $this->DB->fetch($getCats))
		{
			# Get awards to show
			$this->DB->build(array(
									'select'   => '*',
									'from'     => 'inv_awards',
									'where'    => 'parent = ' . $cat['cat_id'],
									'order'    => 'placement ASC',
			));
			
			$this->DB->execute();
			
			$count = $this->DB->getTotalRows();
			
			# Verify we have awards
			if(!$count)
			{
				$rows = "
				<div class='item ipsControlRow' align='center'>
				  <div class='item_info'>
				    <em>This category does not have any awards!</em>
				  </div>
				</div>";
			}
			else
			{
				$num = 1;
				
				while($a = $this->DB->fetch())
				{
					if($a['visible'] && $cat['visible'])
					{
						$visibility = "<a href='javascript: changeStatus_awards({$a['id']});' id='awards_enabler_{$a['id']}'>" . $enabledImage . "</a>";
					}
					else
					{
						$visibility = "<a href='javascript: changeStatus_awards({$a['id']});' id='awards_enabler_{$a['id']}'>" . $disabledImage . "</a>";
					}
					
					$jsAwardsVisibilityArray .= "awardsVisibility[{$a['id']}] = {$a['visible']};";
					
					$rows .= "
					<div class='item ipsControlRow isDraggable' id='award_{$a['id']}'>
					  <div>
					    <table width='100%'>
						  <tr>
						    <td width='2%'><div class='draghandle'></div></td>
						    <td width='5%' align='center'><img src='{$this->settings['upload_url']}/awards/{$a['icon']}' /></td>
					        <td width='75%'>
						      <strong class='forum_name'>{$a['name']}</strong><br />
						      <div class='desctext'>{$a['desc']}</div>
						    </td>
						    <td style='width:8%; text-align:center;'>{$visibility}</td>
							<td style='width:10%; text-align:center;'>
						      <ul class='ipsControlStrip'>
					            <li class='i_edit'>
						          <a href='{$this->settings['base_url']}module=awards&section=manage&do=edit&id={$a['id']}'>Edit Award</a>
					            </li>
						        <li class='i_delete'>
						          <a href='{$this->settings['base_url']}module=awards&section=manage&do=delete&what=award&id={$a['id']}'>Delete Award</a>
					            </li>
				              </ul>
					        </td>
						  </tr>
						</table>
					  </div>
					</div>";
					
					$ids        .= "{$a['id']},";
					$jsAwardCat .= "awardCat[{$a['id']}] = {$cat['cat_id']};";
					
					$num++;
				}
			}
			
			if($cat['cat_id'] == DEFAULT_CAT)
			{
				$catTitleExtra = " <span style='font-wight:100; font-size:12px;'>(<em>Default</em>)</span>";
				$deleteOption  = "<td style='background:transparent; margin:0; padding:0;' width='10%;'>&nbsp;</td>";
			}
			else
			{
				$deleteOption = "
				<td style='background:transparent; margin:0; padding:0; padding-left:15px; text-align:center;' width='10%;'>
				  <ul class='ipsControlStrip'>
				    <li class='i_delete'>
					  <a href='{$this->settings['base_url']}module=awards&section=manage&do=delete&what=category&id={$cat['cat_id']}'>Delete Category</a>
					</li>
				  </ul>
				</td>";
			}
			
			if($count)
			{
				$orderingScript = "
				<script type='text/javascript'>				
				dropItLikeItsHot_cat_{$cat['cat_id']} = function(draggableObject, mouseObject)
				{
					new Ajax.Request('" . str_replace("&amp;", "&", "{$this->settings['base_url']}module=ajax&section=manage&do=order&for=awds&cat={$cat['cat_id']}&") . "secure_key=' + ipb.vars['md5_hash'],
								{
									method: 'post',
									parameters : Sortable.serialize('cat_awds_{$cat['cat_id']}', { tag: 'div', name: 'awds' }),
								}
							);
				
					return false;
				};
				
				Sortable.create('cat_awds_{$cat['cat_id']}', { tag: 'div', only: 'isDraggable', revert: true, format: 'award_([0-9]+)', onUpdate: dropItLikeItsHot_cat_{$cat['cat_id']}, handle: 'draghandle' });
				</script>";
			}
			
			if($cat['visible'] && $count)
			{
				$visibility = "<a href='javascript: changeStatus_category({$cat['cat_id']}, {$count});' id='cat_enabler_{$cat['cat_id']}'>" . $enabledImage . "</a>";
			}
			else
			{
				$visibility = "<a href='javascript: changeStatus_category({$cat['cat_id']}, {$count});' id='cat_enabler_{$cat['cat_id']}'>" . $disabledImage . "</a>";
			}
			
			$jsCatVisibilityArray .= "catVisibility[{$cat['cat_id']}] = {$cat['visible']};";
			$jsCatAwards          .= "catAwards[{$cat['cat_id']}] = \"{$ids}\";";
			
			$categories .= "
			<div class='isDraggable' id='cat_{$cat['cat_id']}'>
			  <div class='root_item item category clearfix ipsControlRow'>
				<div>
				  <table width='100%'>
				    <tr onmouseover='javascript: revealCatDeleteBtn({$cat['cat_id']});' onmouseout='javascript: revealCatDeleteBtn({$cat['cat_id']});'>
				      <td style='background:transparent; margin:0; padding:0;' width='2%'><div class='draghandle'>&nbsp;</div></td>
					  <td style='background:transparent; margin:0; padding:0;' width='80%'>
					    <strong class='larger_text'><span style='cursor:pointer;' id='cat_{$cat['cat_id']}_name' onDblClick='javascript: editCatTitle({$cat['cat_id']});' title='Double Click to Edit!'>{$cat['title']}</span>{$catTitleExtra}</strong></td>
					  <td style='background:transparent; margin:0; padding:0; padding-left:10px; text-align:center;' width='8%;'>{$visibility}</td>
					  {$deleteOption}
				    </tr>
				  </table>
				</div>
			  </div>
			  <div id='cat_awds_{$cat['cat_id']}' class='item_wrap'>
			    {$rows}
			  </div>
			</div>
			{$orderingScript}";
			
			$jsArray .= "catTitles[{$cat['cat_id']}] = '" . addslashes($cat['title']) . "';
			";
			
			unset($catTitleExtra);
			unset($rows);
			unset($orderingScript);
			unset($ids);
		}
		
		$this->registry->getClass('output')->html_main .= "
		<div class='information-box' style='margin-bottom:15px;'>
		  <h4 style='margin-bottom:0; padding-bottom:0;'>Help Using this Page <span style='font-size:10px; font-weight:100;'>(<a href='javascript: showHideInfo();'>Show/Hide Information</a>)</span></h4>
		  <div id='helpDiv' style='display:none; margin-top:15px;'>
		    This page allows you to manage your awards, and the categories which your awards reside in. In an attempt to limit the amount of time you have to wait for pages to load, I have included some quick AJAX functionality. The sections below cover each function you may want to do.<br />
			<br />
			<strong style='text-decoration:underline;'>Altering Category Titles:</strong><br />
			To edit a category's title you must double click the title, and then a text box will appear. To save or cancel, click in the box and then click out of it. (TIP: To retrieve the original value, erase the field and then save it.)<br />
			<br />
			<strong style='text-decoration:underline;'>Changing Order of Awards and Categories:</strong><br />
			Just like other pages in this Admin CP, you can use the drag handel icon to alter the order of the categories and awards on this page.<br />
			<br />
			<strong style='text-decoration:underline;'>Changing Visibility of Awards and Categories:</strong><br />
			If you would like to hide an award, or a category, you can! To do this just click the check mark ({$enabledImage}), or the cross ({$disabledImage}). The check will appear if the award/category is currently enabled, and the cross is just the opposite. You will not be able to enable categories which do not have any awards in them.
		  </div>
		</div>
		<script type='text/javascript'>
		var stylesURL = '{$this->settings['skin_acp_url']}';
		var catTitles = [];
		{$jsArray}
		
		var enabledIMG  = \"{$enabledImage}\";
		var disabledIMG = \"{$disabledImage}\";
		
		var catVisibility = [];
		{$jsCatVisibilityArray}
		
		var awardsVisibility = [];
		{$jsAwardsVisibilityArray}
		
		var catAwards = [];
		{$jsCatAwards}
		
		var awardCat = [];
		{$jsAwardCat}
		</script>
		<script type='text/javascript' src='applications_addon/other/awards/js/manage.js'></script>
		<div class='acp-box'>
		  <h3>Awards Management</h3>
		  <div class='ipsExpandable' id='categories'>
		    {$categories}
	      </div>
		</div>
		<script type='text/javascript'>
		window.onload = function() {
			Sortable.create('categories', { tag: 'div', only: 'isDraggable', revert: true, format: 'cat_([0-9]+)', onUpdate: dropItLikeItsHot, handle: 'draghandle' });
		};
		
		dropItLikeItsHot = function(draggableObject, mouseObject)
		{
			new Ajax.Request('" . str_replace("&amp;", "&", "{$this->settings['base_url']}module=ajax&section=manage&do=order&for=cats&") . "secure_key=' + ipb.vars['md5_hash'],
						{
							method: 'post',
							parameters : Sortable.serialize('categories', { tag: 'div', name: 'cats' }),
						}
					);
		
			return false;
		};
		</script>";
	}
	
	private function deleteAward($SETID="")
	{
		if($SETID)
		{
			$this->request['id']       = $SETID;
			$this->request['continue'] = 1;
		}
		
		# Get the award to show
		$this->DB->build(array(
								'select'   => '*',
								'from'     => 'inv_awards',
								'where' => "id = {$this->request['id']}",
		));
		
		$this->DB->execute();
		$num = $this->DB->getTotalRows();
		
		# Make sure this award exists
		if(!$num || $num > 1)
		{
			$this->registry->output->showError('The URL you have followed is invalid');
		}
		
		$a = $this->DB->fetch();
		
		# Veryify the user didn't skip a step
		if($this->request['continue'])
		{
			if($_POST['deleteAward'] == $a['id'] || $SETID)
			{
				// Delete icon
				if($a['icon'])
				{
					@unlink(UPLOAD_DIR . $a['icon']);
				}
				
				$this->DB->delete('inv_awards_awarded', 'award_id = ' . $a['id']);
				
				// Delete the entire award
				$this->DB->delete('inv_awards', 'id=' . $a['id']);
				
				// Redirect....
				if(!$id)
				{
					$this->registry->output->global_message = "Award Deleted";
					$this->registry->output->silentRedirectWithMessage($this->settings['base_url'] . "module=awards&section=manage");
				}
				else
				{
					return true;
				}
			}
			else
			{
				$this->registry->output->showError('Please make sure you are not skipping a step');
			}
		}
		
		# Check if this award exists in Auto-Award functions
		$this->DB->build(array(
							   'select' => '*',
							   'from'   => 'inv_awards_auto_awards',
							   'where'  => 'award_id = ' . $a['id'],
		));
		
		$this->DB->execute();
		
		if($this->DB->getTotalRows())
		{
			$this->registry->output->showError('This award is being used in some Auto-Award Functions, it must be removed from those before you can delete it.');
		}
		
		$this->registry->getClass('output')->html_main .= "
		<div class='acp-box'>
 		  <h3>Deleting Award: {$a['name']}</h3>
	      <div class='tablerow1' style='padding:10px;'>
			Are you sure that you would like to delete this award, this action cannot be undone.
		  </div>
		  <div class='acp-actionbar'>
		    <form name='deleteAward' method='post' action='{$this->settings['base_url']}module=awards&section=manage&do=delete&what=award&id={$this->request['id']}&continue=1'>
			  <input type='hidden' name='deleteAward' value='{$a['id']}' />
			  <input type='submit' value=' Yes, Delete ' class='realbutton' /> or <strong><a href='{$this->settings['base_url']}'>Cancel</a></strong>
			</form>
	  	  </div>
        </div>";
	}
	
	private function deleteCategory()
	{
		# Get the category
		$this->DB->build(array(
								'select'   => '*',
								'from'     => 'inv_awards_cats',
								'where' => "cat_id = {$this->request['id']}",
		));
		
		$this->DB->execute();
		$num = $this->DB->getTotalRows();
		
		# Make sure this award exists
		if(!$num || $num > 1)
		{
			$this->registry->output->showError('The URL you have followed is invalid');
		}
		
		$c = $this->DB->fetch();
		
		if($c['cat_id'] == DEFAULT_CAT)
		{
			$this->registry->output->showError('This category cannot be deleted');
		}
		
		# Check for awards
		$this->DB->build(array(
								'select'   => '*',
								'from'     => 'inv_awards',
								'where' => "parent = {$c['cat_id']}",
		));
		
		$awds      = $this->DB->execute();
		$numAwards = $this->DB->getTotalRows($awds);
		
		# Is is time to delete?
		if($this->request['continue'] && $this->request['deleteCategory'] == $c['cat_id'])
		{
			# Verify all is OK to delete
			if(!$this->request['awards_option'] && $numAwards)
			{
				$error = "
				<div class='warning' style='margin-bottom:15px;'>
				  <h4><img src={$this->settings['skin_acp_url']}/_newimages/icons/bullet_error.png' /> Error!</h4>
				  You must choose an action to preform with the existing awards in this category.
				</div>";
			}
			else
			{
				# Delete the category
				$this->DB->delete('inv_awards_cats', '`cat_id` = "' . $c['cat_id'] . '"');
				
				# Verify the category has been deleted
				$this->DB->build(array(
										'select'   => '*',
										'from'     => 'inv_awards_cats',
										'where' => "cat_id = {$c['cat_id']}",
				));
				
				$this->DB->execute();
				
				if(!$this->DB->getTotalRows())
				{
					# Do we delete or move the awards
					if(is_numeric($this->request['awards_option']))
					{
						$this->DB->update('inv_awards', array('parent' => $this->request['awards_option']));
					}
					else
					{
						while($awd = $this->DB->fetch($awds))
						{
							$this->deleteAward($awd['id']);
						}
					}
					
					# Redirect
					$this->registry->output->global_message = "Category Deleted";
					$this->registry->output->silentRedirectWithMessage($this->settings['base_url'] . "module=awards&section=manage");
				}
				else
				{
					$error = "
					<div class='warning' style='margin-bottom:15px;'>
					  <h4><img src={$this->settings['skin_acp_url']}/_newimages/icons/bullet_error.png' /> Error!</h4>
					  Deleteing this category has failed
					</div>";
				}
			}
		}
		
		# Show the "this cat has awards" bar
		if($numAwards)
		{
			$awardsOptions = "
			<div style='margin-top:50px; font-weight:bold;' align='center'>
			  This category has awards, what do you want to do with them? &nbsp;&nbsp;&nbsp; " . $this->categoryField($_POST['awardOpt_'], 1, $c['cat_id']) . "
			</div>";
		}
		
		$this->registry->getClass('output')->html_main .= "
		<script type='text/javascript'>
		var totalAwards = {$num};
		var awardsArray = [];
		{$awardsArray}
		</script>
		<script type='text/javascript' src='applications_addon/other/awards/js/delete.js'></script>
		{$error}
		<form name='deleteAward' method='post' action='{$this->settings['base_url']}module=awards&section=manage&do=delete&what=category&id={$this->request['id']}&continue=1'>
		<div class='acp-box'>
 		  <h3>Deleting Category: {$c['title']}</h3>
	      <table class='ipsTable'>
		    <tr>
			  <td>
			    Are you sure that you would like to delete this category, this action cannot be undone.
			    {$awardsOptions}
			  </td>
			</tr>
		  </table>
		  <div class='acp-actionbar'>
		    <input type='submit' value=' Continue ' class='realbutton' /> or <strong><a href='{$this->settings['base_url']}'>Cancel</a></strong>
	  	  </div>
        </div>
		<input type='hidden' name='deleteCategory' value='{$c['cat_id']}' />
		</form>";
	}
	
	private function categoryField($value="", $for="", $noShow="")
	{
		if(!$value && !$for)
		{
			$value = DEFAULT_CAT;
		}
		
		$this->DB->build(array(
							   'select' => '*',
							   'from'   => 'inv_awards_cats',
							   'order'  => 'placement ASC',
		));
		
		$cats = $this->DB->execute();
		
		while($c = $this->DB->fetch($cats))
		{
			if($value == $c['cat_id'])
			{
				$sel = " selected";
			}
			
			if($c['cat_id'] == DEFAULT_CAT)
			{
				$default = " (Default)";
			}
			
			if($noShow != $c['cat_id'])
			{
			    $options .= "<option value='{$c['cat_id']}'{$sel}>{$c['title']}{$default}</option>";
			}
			
			unset($sel);
			unset($default);
		}
		
		if($for)
		{
			return "
			<select name='awards_option'>
			  <option></option>
			  <option value='delete'>Delete</option>
			  <optgroup label='or move to....'>
		 	    {$options}
			  </optgroup>
			</select>";
		}
		else
		{
			return "
			<select name='category'>
		 	  {$options}
			</select>";
		}
	}
	
	private function groupsField($value="")
	{
		$this->DB->build(array(
							   'select' => '*',
							   'from'   => 'groups',
							   'where'  => 'g_can_give_awards = 1',
		));
		
		$this->DB->execute();
		
		while($g = $this->DB->fetch())
		{
			if(strpos($value, $g['g_id'] . ",") !== FALSE)
			{
				$sel = " selected";
			}
			
			$options .= "<option value='{$g['g_id']}'{$sel}>{$g['g_title']}</option>";
			
			unset($sel);
		}
		
		return "
		<select multiple='multiple' size='5' name='public_perms[]'>
		  {$options}
		</select>";
	}
	
	private function addAward()
	{
		# Ready to add it?
		if($this->request['continue'])
		{
			$name = $this->request['award_name'];
			$desc = $this->request['award_desc'];
			$icon = $_FILES['award_icon'];
			$uDir = UPLOAD_DIR;
			
			# Did you enter a name
			if(!$name)
			{
				$this->registry->output->showError('You must enter a name for this award');
			}
			
			# Is your icon good?
			if(!$icon['name'] || strpos($icon['type'], "image") === FALSE)
			{
				$this->registry->output->showError('You can only upload images for the icon');
			}
			
			# Check for the directory
			$this->checkUploadDir($uDir);
			
			$icon['name'] = str_replace(' ', '_', $icon['name']);
			
			# Just incase! ;)
			if(file_exists($uDir . $icon['name']))
			{
				$icon['name'] = rand(1,9999) . "_" . $icon['name'];
			}
			
			# Upload the image
			if(!@move_uploaded_file($icon['tmp_name'], $uDir . $icon['name']))
			{
				$this->registry->output->showError('Adding this award has failed, please try again. (a)');
			}
			
			# Public Perms (version 2.2.2)
			if(count($_POST['public_perms']))
			{
				foreach($_POST['public_perms'] as $perm)
				{
					$publicPerms .= $perm . ",";
				}
			}
			
			# Run the query
			$this->DB->insert('inv_awards', array(
													'name'         => $name,
													'desc'         => $desc,
													'icon'         => $icon['name'],
													'parent'       => $_POST['category'],
													'public_perms' => $publicPerms,
			));
			
			# Check the award was added
			$this->DB->build(array(
									'select' => '*',
									'from'   => 'inv_awards',
									'where'  => 'icon = "' . $icon['name'] . '"',
			));
			
			$this->DB->execute();
			
			if(!$this->DB->getTotalRows())
			{
				$this->registry->output->showError('Adding this award has failed, please try again. (b)');
			}
			
			# Redirect
			$this->registry->output->global_message = "Award Added";
			$this->registry->output->silentRedirectWithMessage($this->settings['base_url'] . "module=awards&section=manage");
		}
		
		$this->registry->getClass('output')->html_main .= "
		<form name='addAward' method='post' action='{$this->settings['base_url']}module=awards&section=manage&do=add&continue=1' enctype='multipart/form-data'>
		<div class='acp-box'>
 		  <h3>Adding Award</h3>
		  <table width='100%' class='alternate_rows double_pad'>
		    <tr>
			  <td width='35%'>
			    <strong>Award Name</strong>
				<div class='desctext'>The award will be identified by this</div>
			  </td>
			  <td><input type='text' name='award_name' size='35' value='{$this->request['award_name']}' /></td>
			</tr>
			<tr>
			  <td>
			    <strong>Award Description</strong>
				<div class='desctext'>Brief description about this award.</div>
			  </td>
			  <td>
			    <textarea name='award_desc' rows='4' cols='30'>{$this->request['award_desc']}</textarea>
			  </td>
			</tr>
			<tr>
			  <td>
			    <strong>Category</strong>
				<div class='desctext'>Choose the category you want this award to be placed into.</div>
			  </td>
			  <td class='tablerow2'>
			    " . $this->categoryField() . "
			  </td>
			</tr>
			<tr>
			  <td>
			    <strong>Public Awarding Permissions</strong>
				<div class='desctext'>Which groups can publicly award this award?</div>
			  </td>
			  <td class='tablerow2'>
			    " . $this->groupsField() . "
			  </td>
			</tr>
			<tr>
			  <td>
			    <strong>Award Icon</strong>
				<div class='desctext'>This is the image representation for this award. It should be about 40x40 pixels, only upload image files.</div>
			  </td>
			  <td>
			    <input type='file' name='award_icon' />
			  </td>
			</tr>
		  </table>
		  <div class='acp-actionbar'>
		    <input type='submit' value=' Add Award ' class='realbutton' /> or <strong><a href='{$this->settings['base_url']}'>Cancel</a></strong>
	  	  </div>
		</div>
		</form>";
	}
	
	private function editAward()
	{
		# Check the award was added
		$this->DB->build(array(
								'select' => '*',
								'from'   => 'inv_awards',
								'where'  => 'id = ' . $this->request['id'],
		));
		
		$this->DB->execute();
		
		if(!$this->DB->getTotalRows())
		{
			$this->registry->output->showError('The URL you have followed is invalid');
		}
		
		$a = $this->DB->fetch();
		
		# Ready to add it?
		if($this->request['continue'])
		{
			$name = $this->request['award_name'];
			$desc = $this->request['award_desc'];
			$icon = $_FILES['award_icon'];
			$uDir = UPLOAD_DIR;
			
			# Did you enter a name
			if(!$name)
			{
				$this->registry->output->showError('You must enter a name for this award');
			}
			
			# Public Perms (version 2.2.2)
			if(count($_POST['public_perms']))
			{
				foreach($_POST['public_perms'] as $perm)
				{
					$publicPerms .= $perm . ",";
				}
			}
			
			$saveIcon = FALSE;
			
			if($icon['name'])
			{
				# Is your icon good?
				if(strpos($icon['type'], "image") === FALSE)
				{
					$this->registry->output->showError('You can only upload images for the icon');
				}
				
				$icon['name'] = str_replace(' ', '_', $icon['name']);
				
				# Just incase! ;)
				if(file_exists($uDir . $icon['name']))
				{
					$icon['name'] = rand(1,9999) . "_" . $icon['name'];
				}
				
				# Check for the directory
				$this->checkUploadDir($uDir);
				
				# Upload the image
				if(!@move_uploaded_file($icon['tmp_name'], $uDir . $icon['name']))
				{
					$this->registry->output->showError('Adding this award has failed, please try again. (a)');
				}
				
				# Delete the old icon
				if($a['icon'])
				{
					unlink($uDir . $a['icon']);
				}
			}
			else
			{
				$icon['name'] = $a['icon'];
			}
			
			# Run the query
			$this->DB->update('inv_awards', array('`name`' => $name, '`desc`' => $desc, '`icon`' => $icon['name'], 'parent' => $_POST['category'], 'public_perms' => $publicPerms), "id = {$a['id']}");
			
			# Redirect
			$this->registry->output->global_message = "Changes Saved";
			$this->registry->output->silentRedirectWithMessage($this->settings['base_url'] . "module=awards&section=manage");
		}
		
		$this->registry->getClass('output')->html_main .= "
		<form name='editAward' method='post' action='{$this->settings['base_url']}module=awards&section=manage&do=edit&id={$a['id']}&continue=1' enctype='multipart/form-data'>
		<div class='acp-box'>
 		  <h3>Editing Award: {$a['name']}</h3>
		  <table width='100%' class='alternate_rows double_pad'>
		    <tr>
			  <td width='35%'>
			    <strong>Award Name</strong>
				<div class='desctext'>The award will be identified by this</div>
			  </td>
			  <td><input type='text' name='award_name' size='35' value='{$a['name']}' /></td>
			</tr>
			<tr>
			  <td>
			    <strong>Award Description</strong>
				<div class='desctext'>Brief description about this award.</div>
			  </td>
			  <td class='tablerow2'>
			    <textarea name='award_desc' rows='4' cols='30'>{$a['desc']}</textarea>
			  </td>
			</tr>
			<tr>
			  <td>
			    <strong>Category</strong>
				<div class='desctext'>Choose the category you want this award to be placed into.</div>
			  </td>
			  <td>
			    " . $this->categoryField($a['parent']) . "
			  </td>
			</tr>
			<tr>
			  <td>
			    <strong>Public Awarding Permissions</strong>
				<div class='desctext'>Which groups can publicly award this award?</div>
			  </td>
			  <td class='tablerow2'>
			    " . $this->groupsField($a['public_perms']) . "
			  </td>
			</tr>
			<tr>
			  <td>
			    <strong>Award Icon</strong>
				<div class='desctext'>This is the image representation for this award. It should be about 40x40 pixels, only upload image files.</div>
			  </td>
			  <td>
			    <span style='color:red; font-weight:bold;'>Leave this blank to not change the award's icon!!!</span><br />
			    <input type='file' name='award_icon' />
			  </td>
			</tr>
		  </table>
		  <div class='acp-actionbar'>
		    <input type='submit' value=' Save Changes ' class='realbutton' /> or <strong><a href='{$this->settings['base_url']}'>Cancel</a></strong>
	  	  </div>
		</div>
		</form>";
	}
	
	private function checkUploadDir($dir)
	{
		if(!is_dir($dir))
		{
			mkdir($dir);
		}
	}
}
?>