<?php
#######################################
## (inv) Awards #######################
#######################################
## Author:  Alec Carpenter
## Website: http://www.invisionenvy.com
#######################################
##                                ADMIN
## Module:  SYSTEM
## Section: ROOT
#######################################
## VERSION: 2.2.4
#######################################


if(!defined('IN_ACP'))
{
	print "<h1>Incorrect access</h1>You cannot access this file directly. If you have recently upgraded, make sure you upgraded 'admin.php'.";
	exit();
}

class admin_awards_system_root extends ipsCommand
{
	public function doExecute(ipsRegistry $registry) 
	{
		$this->DB->build(array(
							   'select' => '*',
							   'from'   => 'inv_awards_awarded',
							   'where'  => 'approved != 1',
		));
		
		$getAwarded = $this->DB->execute();
		
		if($this->DB->getTotalRows())
		{
			while($a = $this->DB->fetch($getAwarded))
			{
				$this->DB->build(array(
									   'select' => '*',
									   'from'   => 'inv_awards',
									   'where'  => 'id = ' . $a['award_id'],
				));
				
				$getAward = $this->DB->execute();
				
				$aa = $this->DB->fetch($getAward);
				
				$to = IPSMember::load($a['user_id']);
				$by = IPSMember::load($a['awarded_by']);
				
				if($a['approved'] < 1 && $a['approved'] > -1)
				{
					$options = "<a href='{$this->settings['base_url']}module=awards&section=award&do=delete&id={$a['row_id']}&from=root' class='ipsBadge badge_red'>DELETE</a> <a href='{$this->settings['base_url']}module=awards&section=award&do=approve&id={$a['row_id']}&from=root' class='ipsBadge badge_green'>APPROVE</a>";
				}
				elseif($a['approved'] < 0)
				{
					$options = "<a href='{$this->settings['base_url']}module=awards&section=award&do=delete&id={$a['row_id']}&from=root' class='ipsBadge badge_red'>DELETE</a> <a href='{$this->settings['base_url']}module=awards&section=award&do=remove&id={$a['row_id']}&active=1&from=root' class='ipsBadge badge_green'>READD</a>";
				}
				
				$row = "
				<tr>
				  <td>{$aa['name']}</td>
				  <td>{$to['members_display_name']}</td>
				  <td>{$by['members_display_name']}</td>
				  <td>{$a['notes']}</td>
				  <td align='right'>{$options}</td>
				</tr>";
				
				if($a['approved'] < 0)
				{
					$removalRows .= $row;
				}
				else
				{
					$givingRows .= $row;
				}
			}
		}
		
		if(!$removalRows)
		{
			$removalRows = "
			<tr>
			  <td colspan='5' align='center'><em>There aren't any awarded awards pending deletion</em></td>
			</tr>";
		}
		
		if(!$givingRows)
		{
			$givingRows = "
			<tr>
			  <td colspan='5' align='center'><em>There aren't any awarded awards pending approval</em></td>
			</tr>";
		}
		
		# Get the latest version
		$curl_lv = curl_init();
		
		curl_setopt($curl_lv, CURLOPT_URL, "http://www.invisionenvy.com/versions/" . INV_APP_NAME . "_latest.html");
		curl_setopt($curl_lv, CURLOPT_HEADER, 0);
		curl_setopt($curl_lv, CURLOPT_RETURNTRANSFER, 1);
		
		$lvd = @curl_exec($curl_lv);
		
		curl_close($curl_lv);
		
		list($latest_version, $long, $download_url) = explode(",", $lvd);
		
		if(!is_numeric($long))
		{
			$latest_version = "Error";
		}
		else
		{
			if($long > INV_APP_VERSION_LONG)
			{
				$dwnld = " 
				<tr>
				  <td colspan='2' align='center'><a href='{$download_url}' target='_blank' class='ipsBadge badge_green'>Download Version {$latest_version} from Invision Envy</a></td>
				</tr>";
			}
		}
		
		$this->registry->getClass('output')->html_main = "
		<script type='text/javascript' src='applications_addon/other/awards/js/admin.js'></script>
		<div class='section_title'>
		  <h2>System Overview</h2>
		</div>
		<div style='float:right; width:39%;'>
		  <div class='acp-box'>
 		    <h3>System Information</h3>
		  </div>
		  <div class='acp-box' style='margin-top:10px;'>
			<table class='ipsTable'>
			  <tr>
			    <td width='50%'><strong>Application Name</strong></td>
				<td align='center'>(inv) Awards</td>
			  </tr>
			</table>
		  </div>
		  <div class='acp-box' style='margin-top:10px;'>
			<table class='ipsTable'>
			  <tr>
			    <td width='50%'><strong>Current Version</strong></td>
				<td align='center'>" . INV_APP_VERSION . "</td>
			  </tr>
			  <tr>
			    <td width='50%'><strong>Latest Version</strong></td>
				<td align='center'>{$latest_version}</td>
			  </tr>
			  {$dwnld}
			</table>
		  </div>
		  <div class='acp-box' style='margin-top:10px;'>
			<table class='ipsTable'>
			  <tr>
			    <td class='tablerow1' align='center'>(inv) Awards produced by Alec Carpenter of <a href='http://www.invisionenvy.com/' target='_blank'>Invision Envy</a></td>
			  </tr>
	        </table>
		  </div>
		</div>
		<div style='float:left; width:60%;'>
		  <div class='acp-box'>
 		    <h3>Awards Pending Approval</h3>
			<table class='ipsTable'>
			  <tr>
			    <th width='20%'>Award</th>
				<th width='20%'>Awarded To</th>
				<th width='20%'>Awarded By</th>
				<th width='20%'>Notes</th>
				<th width='20%'></th>
			  </tr>
			  {$givingRows}
			</table>
		  </div>
		  <br />
		  <div class='acp-box'>
 		    <h3>Awards Pending Deletion</h3>
			<table class='ipsTable'>
			  <tr>
			    <th width='20%'>Award</th>
				<th width='20%'>Awarded To</th>
				<th width='20%'>Awarded By</th>
				<th width='20%'>Notes</th>
				<th width='20%'></th>
			  </tr>
			  {$removalRows}
			</table>
		  </div>
		</div>
		<div style='clear:both;'></div>";
		
		$this->registry->getClass('output')->sendOutput();
	}
}
?>