<?php
#######################################
## (inv) Awards #######################
#######################################
## Author:  Alec Carpenter
## Website: http://www.invisionenvy.com
#######################################
##                               PUBLIC
## Module:  AJAX
## Section: AWARDS
#######################################
## VERSION: 2.2.3
#######################################

if (!defined('IN_IPB'))
{
	print "<h1>Incorrect access</h1>You cannot access this file directly. If you have recently upgraded, make sure you upgraded all the relevant files.";
	exit();
}

class public_awards_ajax_awards extends ipsAjaxCommand
{
	public function doExecute(ipsRegistry $registry)
	{
		# Verify we have a valid request
		if($this->request['do'] == "getAwarded")
		{
			# Get the language
			$this->lang->loadLanguageFile(array("public_awards"));
			
			# Run the query
			$this->DB->build(array(
									'select' => 'a.user_id',
									'from'   => array('inv_awards_awarded' => 'a'),
									'add_join' => array(
														0 => array(
																   'select' => 'm.member_id,m.members_seo_name,m.members_display_name',
																   'from'   => array('members' => 'm'),
																   'where'  => 'm.member_id = a.user_id',
														),
									),
									'where'  => "`award_id` = '{$_POST['id']}' && `is_active` = '1' && `approved` = '1'",
			));
			
			$this->DB->execute();
			
			# See what we got
			$count = $this->DB->getTotalRows();
			
			if(!$count)
			{
				$this->returnHTML($this->lang->words['error_no_awarded']);
			}
			else
			{
				# Get the awarded users
				$AWARDED = array();
				
				$num = 0;
				while($a = $this->DB->fetch())
				{
					if(!isset($AWARDED[$a['member_id']]))
					{
						$AWARDED[$a['member_id']] = array($a['members_seo_name'], $a['members_display_name']);
					}
				}
				
				# Refine the awarded users list
				$num = 0;
				foreach($AWARDED as $id => $name)
				{
					if($num > 0 && $num < $count)
					{
						$comma = ", ";
					}
					
					$url     = ipsRegistry::getClass('output')->buildSEOUrl('showuser=' . $id . '&tab=awards', 'public', $name[0], 'showuser');
					$return .= $comma . "<a href='{$url}'>{$name['1']}</a>";
					
					$num++;
				}
				
				if(!$return)
				{
					$return = $this->lang->words['error_no_awarded'];
				}
				
				$this->returnHTML($return);
			}
		}
	}
}
?>