<?php
if(!defined('IN_IPB'))
{
	print "<h1>Incorrect access</h1>You cannot access this file directly. If you have recently upgraded, make sure you upgraded all the relevant files.";
	exit();
}

class class_awards
{
	protected $registry;
	protected $DB;
	protected $settings;
	protected $request;
	protected $member;
	
	public function __construct( ipsRegistry $registry )
	{
		$this->registry   = $registry;
		$this->DB         = $this->registry->DB();
		$this->settings   =& $this->registry->fetchSettings();
		$this->request    =& $this->registry->fetchRequest();
		$this->member     = $this->registry->member();
		$this->memberData =& $this->registry->member()->fetchMemberData();
	}
	
	public function canPublic_Award($memberData)
	{
		$currentMember = ipsRegistry::instance()->member()->fetchMemberData();
		
		if($this->settings['awds_group_restricted'])
		{
			$mGroups     = $memberData['member_group_id'] . ",";
			$cMemberGrps = $currentMember['member_group_id'] . ",";
			
			if($this->settings['awds_include_sub_groups'])
			{
				$mGroups     .=  $memberData['mgroup_others'];
				$cMemberGrps .= $currentMember['mgroup_others'];
			}
			
			$expldC   = explode(",", $cMemberGrps);
			$expldM   = explode(",", $mGroups);
			$continue = FALSE;
			
			foreach($expldC as $num => $id)
			{
				if(!$pos[$id] && $id)
				{
					$pos[$id] = 1;
				}
			}
			
			foreach($expldM as $num => $id)
			{
				if($pos[$id])
				{
					$continue = TRUE;
				}
			}
		}
		
		if($continue !== FALSE)
		{
			$continue = TRUE;
			
			if(!$this->settings['awds_self_awd_public'] && $currentMember['member_id'] == $memberData['member_id'])
			{
				$continue = FALSE;
			}
			
			if(!$currentMember['g_can_give_awards'] || !$memberData['g_can_receive_awards'])
			{
				$continue = FALSE;
			}
			
			if($this->memberData['g_access_cp'] &&!$continue)
			{
				$continue = TRUE;
			}
			
			return $continue;
		}
		else
		{
			return FALSE;
		}
	}
	
	public function autoAward($key, $data)
	{
		$dir = AUTO_FUNCS_DIR . "/" . $key . ".php";
		
		if(file_exists($dir))
		{
			include_once($dir);
			
			$class  = "auto_award_" . $key;
			$call   = new $class(ipsRegistry::instance());
			
			$this->DB->build(array(
								   'select' => '*',
								   'from'   => 'inv_awards_auto_awards',
								   'where'  => 'type = "' . $key . '" && enabled = 1',
			));
			
			$this->DB->execute();
			
			if($this->DB->getTotalRows())
			{
				$process = array();
				
				while($f = $this->DB->fetch())
				{
					$process[$f['inst_id']] = array(
													'award' => $f['award_id'],
													'data'  => json_decode($f['data'], TRUE),
					);
				}
				
				$call->run($process, $data);
			}
		}
		else
		{
			return false;
		}
	}
	
	public function doAutoAward($func, $user, $duplicate=0)
	{
		if(!$duplicate)
		{
			$this->DB->build(array(
								   'select' => '*',
								   'from'   => 'inv_awards_awarded',
								   'where'  => 'user_id = ' . $user . ' && auto_award_id = ' . $func,
			));
			
			$this->DB->execute();
			
			if($this->DB->getTotalRows())
			{
				return;
			}
		}
		
		$this->DB->build(array(
							   'select' => '*',
							   'from'   => 'inv_awards_auto_awards',
							   'where'  => 'inst_id = ' . $func,
		));
			
		$this->DB->execute();
		
		$f = $this->DB->fetch();
		
		$INSERT = array(
						'award_id'      => $f['award_id'],
						'auto_award_id' => $f['inst_id'],
						'user_id'       => $user,
						'awarded_by'    => $this->settings['awds_auto_user_id'],
						'notes'         => $f['notes'],
						'date'          => IPS_UNIX_TIME_NOW,
		);
		
		$this->DB->insert('inv_awards_awarded', $INSERT);
	}
}
?>